Subject: Re: Database Over Flow Doubt

From: "Manral, Vishwas" <[email-masked]>
Date: Tue, 25 Jun 2002 00:50:06 -0400

Hi Amit,

Yes, you made urself clear the first time around. However as I said its the
way you want to implement things. The RFC helps in preventing LSA's more
than Overflow from being injected in the domain however the way you manage
the internals of your OSPF instance is at your discretion.

Say you can store 500 LSA's or 400 LSA's + 100 External Information elements
in the router. You could set the DBOVerflow value to 400, and store any
additional External Information elements. However if the number of info
elements comes close to 100 you could set the DBoverflow timer to value
0(never come out of overload state), flush all originated LSA's and remove
all the information elements. The idea here is that we can allow at the most
400 LSA's in the domain however we have enough memory to originate 100 more
LSA's. This is just an example of how you could do things.

You can do internal things anyway you want, as long as you can achieve the
objectives of the RFC using the mechanisms in the RFC.

Thanks,
Vishwas

-----Original Message-----
From: Amit Srivastava [mailto:[email-masked]]
Sent: Tuesday, June 25, 2002 9:31 AM
To: [email-masked]
Subject: Re: Database Over Flow Doubt

Hi Vishwas ,
        That is my point how can u store all the
LSA(400 in the example of RFC) when we are flushing
the LSA's from the database just bcoz we think that
there is no space for the other LSA's.
         The purpose of writing the RFC here itself is
being hamperred if we store the flushed alway LSA
again the same memory problem will persist!!
Hope i made my self clear!!
Regards
Amit
--- "Manral, Vishwas" <[email-masked]> wrote:
> Amit,
>
> You can do it either way, as long as you are somehow
> able to get back the
> LSA's that you wanted to originate and that you
> could not originate, when
> you come out of overflow state.
>
> Thanks,
> Vishwas
>
> -----Original Message-----
> From: Amit Srivastava [mailto:[email-masked]]
> Sent: Monday, June 24, 2002 11:32 AM
> To: [email-masked]
> Subject: Database Over Flow Doubt
>
>
> Hi Vishwas!!
>   I have one more doubt the RFC 1765 say in example
> (section 3) that when the OSPF timer expires then it
> tries to come out of the database overflow state and
> originates all the 400 non default AS-Exteranl
> LSA.Is
> it that before flushing the LSA it keeps the LSA in
> a
> linklist form and after the timer expires it
> originates the LSA again!!If this is the case then i
> have small doubt :-
>              We have flushed the link state database
> because we think that we cannot accomodate any other
> LSA.Now keeping the log of all the flushed LSA would
> not be a good idea what i feel!!!
> What do u say??
> Regards
> Amit
>
> --- "Manral, Vishwas" <[email-masked]> wrote:
> > Amit,
> >
> > When the administrator finds that a domain is
> > getting "Overflows" he has to
> > change the policies so that the number of routes
> > imported into the domain is
> > reduced. The routes to be imported are all an
> > administrative
> > decision/policies and the OSPF packets etc do not
> > come into picture at all.
> >
> > The RFC in this point talks about importing routes
> > from other domains and
> > not about received LSA's from other routers in the
> > domain.
> >
> > Thanks,
> > Vishwas
> >
> > -----Original Message-----
> > From: Amit Srivastava [mailto:[email-masked]]
> > Sent: Friday, June 21, 2002 4:35 PM
> > To: [email-masked]
> > Subject: Re: OSPF Retransmission Doubt
> >
> >
> >  Hi Vishwas!!
> >       The RFC 1765 section 4 last point states
> that
> > if
> > the administrator cannot incresase the value of
> > ospfExtlsdbLimit then he can make sure that more
> > important routes continue to be imported ; this is
> > accomplished by turning off the importing of less
> > important routes.
> >       Now my doubt is ->is it that the
> administrator
> > configures paticular n/w coming in the AS-external
> > packet as important or unimportant or does it mean
> > that routes learned by a paticular router-id are
> > important and will stay in the database while all
> > the
> > others will be flushed or is it implementation
> > specific!!!
> > Regards
> > Amit
> >
> >
> >
> >
> > --- "Manral, Vishwas" <[email-masked]>
> wrote:
> > > Hi Amit,
> > >
> > > The case would not occur if all the routers
> would
> > > have the same value of
> > > ExtLSDBLimit except in the transient condition.
> > > Section 2.2 first part would
> > > only occur if the value is not the same this may
> > be
> > > required. Its always
> > > better to check the condition, if we are
> exceeding
> > > the limit and accordingly
> > > take action to get over any such a case.
> > >
> > > Section 2.3 states that the flooding
> modification
> > > would only be invoked
> > > during a "short period of convergence" for same
> > > value of LSDBLimit. Such a
> > > case would only occur say when two routers are
> > > symultaneously originating
> > > AS-External LSA's. So when they are originating
> > the
> > > LSA's the LSDB limit is
> > > not exceeded however when they are receiving the
> > > LSA's from the other the
> > > LSDB limit is exceeded. However as the RFC
> states
> > > this would be a transient
> > > condition.
> > >
> > > Thanks,
> > > Vishwas
> > >
> > > -----Original Message-----
> > > From: Amit Srivastava
> [mailto:[email-masked]]
> > > Sent: Thursday, June 20, 2002 10:24 AM
> > > To: [email-masked]
> > > Subject: Re: OSPF Retransmission Doubt
> > >
> > >
> > > Hi Vishwas,
> > >    I have a small doubt .If u refer to section
> 2.2
> > > and
> > > 2.3 of RFC 1765 it states that during flooding
> > also
> > > the variable count of non-default AS_external
> LSA
> > is
> > > incremented( if we receive a non-default
> > AS-external
> > > LSA during flooding).But if we have a common
> > thresh
> > > hold limit i.e variable ospfExtlsdbLimit is same
> > for
> > > all the router how come this condition will be
> > > encountered???
> > > Regards
> > > Amit
> > >
> > >
> > >
> > >
> > > --- "Manral, Vishwas" <[email-masked]>
> > wrote:
> > > > Hi Amit,
> > > >
> > > > I do not think any RFC which talks about
> > > non-default
> > > > type-3 LSA's exists.
> > > > The RFC1765 only talks about type-5 LSA's
> > however
> > > it
> > > > could be extended for
> > > > other type of LSA's i.e. type-7, type-11.
> > > >
> > > > Thanks,
> > > > Vishwas
> > > >
> > > > -----Original Message-----
> > > > From: Amit Srivastava
> > [mailto:[email-masked]]
> > > > Sent: Wednesday, June 19, 2002 11:43 AM
> > > > To: [email-masked]
> > > > Subject: Re: OSPF Retransmission Doubt
> > > >
> > > >
> > > >
> > > >  Hi Erblich and Vishwas,
> > > >       Erblich I got your point but is there
> any
> > > > Draft or RFC which
> > > > states
> > > > this??
> > > >      And Vishwas thanks for your help i would
> > also
> > > > like to know if
> > > > there is any draft which states that we can
> > > withdraw
> > > > Summary 3 and 4
> > > > non-default LSA.Because The RFC 2370 specks
> very
> > > > little about it.
> > > > Regards
> > > > Amit

---

From: mohit gurnani <[email-masked]>
Date: Wed, 26 Jun 2002 13:46:30 +0530

Hi Amit,

You are right in saying that rotuer will keep on going into overflow unless the number routes do not get reduced, or unless the administrator does not remove a few (less important) redistributes or some other corrective action is taken.

The RFC recognoses the problem that the router may go into Overflow again and again.See RFC-1765 point 4
Administrative response to database overflow.

I am not sure how much effective the log will be (how much memory will it be able to clear up). Also if you rely on the log only, when the router comes out of overflow, you will have to ensure that all the log entries are still valid. Because some routes might have been deleted from the routing table while the router was in overflow. Also during Overflow state you cannot import any new routes that may get added into the routing table. All the new routes that get added into the routing table and can be imported will also need to be put into the log.

Regards

Mohit

>Reply-To: Mailing List

>Date: Tue, 25 Jun 2002 23:09:31 -0700

>Hi mohit,

> Even this method seems to be prone to

>errors.Consider the case:-

> At time 12:40 PM the administartor gave the

>command redistribute bgp.This will put all the bgp

>routes in the ospf domain.Now due to this the ospf

>router goes in to the Overflow state.Now at 1:40 PM it

>recovers(when the timer expires)and would try to

>originate the LSA .To do so, from programme only he

>would call redistribute bgp.

> Now the problem is by this time BGP would

>have learned lot more routes which administrator would

>not like to flood them to ospf domain!!But as the

>redistribute bgp is called from the program this

>condition is unavoidable!!

> So i feel making log is better idea!!

>What do you say!!

>--- mohit gurnani wrote:

Hi Amit,

What I want to say, in as little words

>as possibe, is that delete every flushed LSA that is

>acknowledged and donot maintain a log.

The router must maintain all the

>routes (OSPF or otherwise) in some sort of a routing

>table. This routing table must provide an interface by

>means of which you can pick routes one by one (maybe

>some sort of get, get-first, get-next kind of

>interface). So what you do is pick first route, check

>if it is an active route (maybe even check if  it

>is not an OSPF route because a router cannot import

>its own OSPF routes), check if the router allows you

>to import it by means of policy filters. Import

>policies like distribute-out and redistribute

>can be configured on the system. eg. if you have only

>Redistribute BGP configured, you are allowed to import

>all BGP routes and no other routes. And if the route

>can be imported, use its fields to construct a new

>external LSA, update your database and flood the LSA.

>You do this for all the routes in the routing table

>once the OverflowExitTimer expires.

And it is advisable that you

>do import of routes in batches (say 500

>routes a second) and not all in one go because the

>process is long and might affect system overall

>performance.

Regards

Mohit

>Reply-To: Mailing List

>Date: Mon, 24 Jun 2002 22:09:42 -0700

>Hi Mohit!!

> could you please explain your answer

>(i mean the

>last two lines).Sorry i could not get

>you!!

>--- mohit gurnani

Hi Amit,

The external LSAs are originated

>by scanning through external (non-OSPF)

>routes and

>applying filtering policies to filter

>out routes which

>cannot be imported. All the routes that

>pass policies

>are imported in form of external LSAs.

Now when the system goes into

>overflow, the non-default

>self-originated LSAs are

>flushed and subsequently deleted from

>the database.

>You are right when you say it is a bad

>idea to

>maintain the log. It will defeat the

>whole purpose of

>Overflow implementation which aims at

>clearing up

>memory.What is advisable instead to

>delete all LSAs

>once acknowledged, and when the

>Overflow Exit Timer

>expires, scan through all the external

>routes once

>again, apply policy rules and re-import

>routes that

>pass policy.

Regards

Mohit

>From: Amit

>Srivastava

>Reply-To: Mailing

>List

>Date: Sun, 23 Jun 2002 23:02:19 -0700

> I have one more doubt the RFC 1765 say

>in example

>(section 3) that when the OSPF timer

>expires then it

>tries to come out of the database

>overflow state and

>originates all the 400 non default

>AS-Exteranl LSA.Is

>it that before flushing the LSA it

>keeps the LSA in a

>linklist form and after the timer

>expires it

>originates the LSA again!!If this is

>the case then i

> We have flushed the link state

>database

>because we think that we cannot

>accomodate any other

>LSA.Now keeping the log of all the

>flushed LSA would

>--- "Manral,

>Vishwas" wrote:

> > When the administrator finds that

>a domain is

> > getting "Overflows" he

>has to

> > change the policies so that the

>number of routes

> > reduced. The routes to be

>imported are all an

> > decision/policies and the OSPF

>packets etc do not

> > The RFC in this point talks about

>importing routes

> > not about received LSA's from

>other routers in the

> > Sent: Friday, June 21, 2002 4:35

>PM

> > Subject: Re: OSPF Retransmission

>Doubt

> > The RFC 1765 section 4 last point

>states that

> > the administrator cannot

>incresase the value of

> > ospfExtlsdbLimit then he can make

>sure that more

> > important routes continue to be

>imported ; this is

> > accomplished by turning off the

>importing of less

> > Now my doubt is ->is it that

>the administrator

> > configures paticular n/w coming

>in the AS-external

> > packet as important or

>unimportant or does it mean

> > that routes learned by a

>paticular router-id are

> > important and will stay in the

>database while all

> > others will be flushed or is it

>implementation

> > --- "Manral,

>Vishwas" wrote:

> > > The case would not occur if

>all the routers would

> > > ExtLSDBLimit except in the

>transient condition.

> > > only occur if the value is

>not the same this may

> > > better to check the

>condition, if we are exceeding

> > > take action to get over any

>such a case.

> > > Section 2.3 states that the

>flooding modification

> > > during a "short period

>of convergence" for same

> > > case would only occur say

>when two routers are

> > > AS-External LSA's. So when

>they are originating

> > > not exceeded however when

>they are receiving the

> > > LSDB limit is exceeded.

>However as the RFC states

> > > Sent: Thursday, June 20,

>2002 10:24 AM

> > > To:

>[email-masked]

> > > Subject: Re: OSPF

>Retransmission Doubt

> > > I have a small doubt .If u

>refer to section 2.2

> > > 2.3 of RFC 1765 it states

>that during flooding

> > > the variable count of

>non-default AS_external LSA

> > > incremented( if we receive a

> > > LSA during flooding).But if

>we have a common

> > > hold limit i.e variable

>ospfExtlsdbLimit is same

> > > all the router how come this

>condition will be

> > > --- "Manral,

>Vishwas"

> > > > I do not think any RFC

>which talks about

> > > > The RFC1765 only talks

>about type-5 LSA's

> > > > other type of LSA's

>i.e. type-7, type-11.

> > > > -----Original

>Message-----

> > > > Sent: Wednesday, June

>19, 2002 11:43 AM

> > > > To:

>[email-masked]

> > > > Subject: Re: OSPF

>Retransmission Doubt

> > > > Erblich I got your

>point but is there any

> > > > And Vishwas thanks for

>your help i would

> > > > there is any draft

>which states that we can

> > > > non-default LSA.Because

>The RFC 2370 specks very

>Srivastava wrote:

> > > > Hi Vishwas!

> > > > Actually after reading

>the RFC 1765

> > only

> > > i

> > > > got this doubt.Here i

> > > > feel once the

>OSPFEXTLSDBLinit variable is

> > > exceeded

> > > > the router should

> > > > indicate other routers

>that its database is full

> > > > they should not keep on

> > > > retransmitting the LSA

>which will clog the n/w

> > > > bandwidth.Once the

>router

> > > > comes out of the

>database overflow state it

> > should

> > > > indicate to the other

> > > > router that now they

>should send the LSA.

> > > > What do you say about

> > > > "Manral,

>Vishwas"

> > > > You may like to look at

>the RFC1765 - OSPF

> > > Database

> > > > Overflow.

>http://www.ietf.org/rfc/rfc1765.txt

>This RFC

> > tells

> > > > way to deal with such

> > > > overflow when it occurs

>in OSPF.

> > > > Also as the RFC lists

>as enhancements, if the

> > > number

> > > > of summary LSA's

>=== message truncated ===

>__________________________________________________

>Do You Yahoo!?

>Yahoo! - Official partner of 2002 FIFA

>World Cup

>http://fifaworldcup.yahoo.com

>Get your FREE

>download of MSN Explorer at ><>>href='http://g.msn.com/1HM503401/37'>http://explorer.msn.com.

>__________________________________________________

>Do You Yahoo!?

>Yahoo! - Official partner of 2002 FIFA

>World Cup

>http://fifaworldcup.yahoo.com

MSN Photos is the

>easiest way to share and print your photos: >href='http://g.msn.com/1HM1ENIN/c156??PI=44344'>Click

>Here

>__________________________________________________

>Do You Yahoo!?

>Yahoo! - Official partner of 2002 FIFA World Cup

>http://fifaworldcup.yahoo.com

Send and receive Hotmail on your mobile device: Click Here